#include <Ice/Ice.h>
#include <Hello.h>

using namespace std;
using namespace Demo;

struct Rec
{
	HelloPrx one;
	HelloPrx two;
};


class HelloClient : public Ice::Application
{
public:

    HelloClient();

    virtual int run(int, char*[]);

	static unsigned __stdcall thread_func(void* rec)
	{
		Ice::ByteSeq buffer(512 * 1024);

		Ice::Long count = 0;

		while (true)
		{
			try {
				::Demo::DfsWriteStreamPrx s1 = (*(Rec*)rec).one->openWrite("");
				::Demo::DfsWriteStreamPrx s2 = (*(Rec*)rec).two->openWrite("");

				for (int i = 0; i < 1; ++i)
				{
					s1->write(0L, std::make_pair(&buffer[0], &buffer[0] + buffer.size()));
					s2->write(0L, std::make_pair(&buffer[0], &buffer[0] + buffer.size()));
				}

				s1->release();
				s2->release();

				if (++count %100 == 0)
				{
					std::cout << "Thread " << GetCurrentThreadId() << ",  Iteration #" << count <<std::endl;
				}
			}
			catch(const Ice::Exception& ex)
			{
				cerr << ex << endl;
			}
		}

		return 0;
	}
};

int
main(int argc, char* argv[])
{
    HelloClient app;
    return app.main(argc, argv, "config.client");
}

HelloClient::HelloClient() :
    //
    // Since this is an interactive demo we don't want any signal
    // handling.
    //
    Ice::Application(Ice::NoSignalHandling)
{
}

int
HelloClient::run(int argc, char* argv[])
{
    if(argc > 1)
    {
        cerr << appName() << ": too many arguments" << endl;
        return EXIT_FAILURE;
    }

    HelloPrx s1 = HelloPrx::checkedCast(
        communicator()->propertyToProxy("Hello.Proxy"));

	if(!s1)
    {
        cerr << argv[0] << ": invalid proxy" << endl;
        return EXIT_FAILURE;
    }

    HelloPrx s2 = HelloPrx::checkedCast(
		communicator()->stringToProxy("hello:tcp -h localhost -p 10000"));

	if(!s2)
    {
        cerr << argv[0] << ": invalid proxy" << endl;
        return EXIT_FAILURE;
    }

	for (int i = 0; i < 100; ++i)
	{
		Rec* rec = new Rec();
		rec->one = s1;
		rec->two = s2;
		_beginthreadex(0, 0, thread_func, rec, 0, 0);
	}

	std::string s;
	std::cin >> s;

    return EXIT_SUCCESS;
}
