// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#include <IceUtil/IceUtil.h>
#include <Ice/Ice.h>
#include <HelloI.h>

using namespace std;

using namespace ::Demo;

DfsWriteStreamPrx HelloI::openWrite(const ::std::string& name, const Ice::Current& c)
{
	IceUtil::Handle<DfsWriteStreamI> stream = new DfsWriteStreamI();
	
	return DfsWriteStreamPrx::uncheckedCast(c.adapter->addWithUUID(stream));
}

void HelloI::shutdown(const Ice::Current& c)
{
    cout << "Shutting down..." << endl;
    c.adapter->getCommunicator()->shutdown();
}

void DfsWriteStreamI::write(::Ice::Long, const ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*>&, const Ice::Current&)
{
}

void DfsWriteStreamI::release(const Ice::Current& c)
{
	c.adapter->remove(c.id);
}
